Aspose.Diagram for Node.js via Java is a scalable and feature-rich API to integrate Microsoft Visio® file generation, manipulation, conversion & processing features into your own Node.js applications. It allows your applications to work with Microsoft Visio Object Model in order to create the diagrams from scratch, edit existing diagrams or convert diagrams to popular formats including PDF, HTML, images and other Visio formats.

## Node.js Diagram API Features 
- Programmatically create new Microsoft Visio diagrams via API.
- Convert Visio flow-charts to other supported formats.
- Retrieve document information of a Visio file.
- Export Visio files to raster images, fixed-layout and HTML formats.

## Read & Write Visio File Formats

**Microsoft Visio:** VSDX, VSX, VTX, VDX, VSSX, VSTX, VSDM, VSSM, VSTM

## Save Visio Diagrams As

**Fixed Layout:** PDF, XPS
**Images:** JPEG, PNG, BMP, TIFF, SVG, EMF
**Web:** HTML
**Other:** XAML

## Read Visio Formats

**Microsoft Visio:** VDW, VSD, VSS, VST

## Getting Started with Aspose.Diagram for Nodejs via Java

Execute `npm install aspose.diagram --save` from the command line to install Aspose.Diagram for Node.js via Java in order to get started. Now, you are ready to execute any of the following code snippets or you may check the detailed Developer's Guide for all possible usage scenarios. 	
	
### Create Visio VSDX File from Scratch using Node.js
``` js
var aspose = aspose || {};
aspose.diagram = require("aspose.diagram");

var diagram = new aspose.diagram.Diagram();
diagram.save("output.vsdx", aspose.diagram.SaveFileFormat.VSDX);
```

### Export Page of Visio VSDX File to PNG Format
``` js
var aspose = aspose || {};
aspose.diagram = require("aspose.diagram");

diagram = new aspose.diagram.Diagram("template.vsdx");

// Save diagram as PNG
options = new aspose.diagram.ImageSaveOptions(aspose.diagram.SaveFileFormat.PNG);

// Save one page only, by page index
options.setPageIndex(0);

// Save resultant Image file
diagram.save("output.png", options);
```

[Product Page](https://products.aspose.com/diagram/nodejs-java) | [Product Documentation](https://docs.aspose.com/display/diagramnodejsjava/Aspose.Diagram+for+Node.js+via+Java+Home) | [Blog](https://blog.aspose.com/category/diagram/) |[API Reference](https://apireference.aspose.com/nodejs/diagram) | [Source Code Samples](https://github.com/aspose-diagram/Aspose.Diagram-for-Java) | [Free Support](https://forum.aspose.com/c/diagram) | [Temporary License](https://purchase.aspose.com/temporary-license)
